unit AnwesenheitsUnit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, ActnList;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Edit1: TEdit;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ListBox1: TListBox;
    ListBox2: TListBox;
    ListBox3: TListBox;
    ListBox4: TListBox;
    OpenDialog1: TOpenDialog;
    OpenDialog2: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit1Enter(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure ListBox4Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private

  public

  end;

const version='v0.6';
      build='2021-03-05';

var
  Form1: TForm1;
  daten       : array[1..500,1..5] of string;
  zahler      : word;
  HasAnythingBeenOpened : Boolean;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  ListBox3.Items.Add('AnwesenheitsApp '+version);
  ListBox3.Items.Add('(build '+build+')');
  HasAnythingBeenOpened:=false;
end;

procedure TForm1.ListBox4Click(Sender: TObject);
begin

end;

procedure TForm1.Button1Click(Sender: TObject);
var
  filename: string;
  datei:text;
  s:string;
  n,m:word;
begin
  if (HasAnythingBeenOpened and (MessageDlg('Achtung: Alle nicht gespeichterten Änderungen gehen verloren!  Weiter?', mtConfirmation, [mbOk, mbCancel], 0) = mrOk))
    or (HasAnythingBeenOpened=false) then
  if OpenDialog1.Execute then
  begin
    filename := OpenDialog1.Filename;
    ListBox1.Items.Clear;
    ListBox2.Items.Clear;
    ListBox3.Items.Clear;
    ListBox4.Items.Clear;
    Edit1.Text:='';
    Label1.Caption:='offen/unentschuldigt';
    Label2.Caption:='anwesend';
    Label3.Caption:='ohne Anmeldung';
    HasAnythingBeenOpened:=true;
    Zahler:=0;
    s:='';

    assignfile(datei,filename);
    reset(datei);
    if not eof(datei) then readln(datei,s);
    if s=chr($EF)+chr($BB)+chr($BF)+'Name;Vorname;Matrikelnummer;Kartennummer;Status' then
      while not eof(datei) do
      begin
        inc(zahler);
        daten[zahler,1]:='';
        daten[zahler,2]:='';
        daten[zahler,3]:='';
        daten[zahler,4]:='';
        daten[zahler,5]:='';
        readln(datei,s);
        m:=1;
        for n:=1 to length(s) do
        begin
          if copy(s,n,1)=';' then
          begin
            inc(m);
            if m>5 then m:=5;
          end else
            daten[zahler,m]:=daten[zahler,m]+copy(s,n,1);
        end
      end
      else ShowMessage('Erste Zeile nicht "Name;Vorname;Matrikelnummer;Kartennummer;Status" oder Datei nicht in UTF8-BOM-Kodierung.');
    closefile(datei);
    for n:=1 to zahler do
        if daten[n,5]='offen' then daten[n,5]:='unentschuldigt';
    for n:=1 to zahler do
      case daten[n,5] of
        'unentschuldigt':   ListBox1.Items.Add(daten[n,3]+' ('+daten[n,4]+'):     '+daten[n,1]+' '+daten[n,2]);
        'anwesend':         ListBox2.Items.Add(daten[n,3]+' ('+daten[n,4]+'):     '+daten[n,1]+' '+daten[n,2]);
        'ohne Anmeldung':   ListBox3.Items.Add(daten[n,3]+' ('+daten[n,4]+'):     '+daten[n,1]+' '+daten[n,2]);
      end;
    end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var filename: string;
    datei:text;
    n:word;
begin
  if HasAnythingBeenOpened then
    if SaveDialog1.Execute then
    begin
      filename := SaveDialog1.Filename;
      assignfile(datei,filename+'.csv');
      rewrite(datei);
      writeln(datei,chr($EF)+chr($BB)+chr($BF)+'Name;Vorname;Matrikelnummer;Kartennummer;Status');
      for n:=1 to zahler do
        writeln(datei,daten[n,1]+';'+daten[n,2]+';'+daten[n,3]+';'+daten[n,4]+';'+daten[n,5]);
      closefile(datei);
      ShowMessage('Liste wurde exportiert.');
    end;
    if not HasAnythingBeenOpened then ShowMessage('Es gibt nichts zu speichern.');
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  konvfilename: string;
  konvin:text;
  konvout:text;
  konvs:string;
begin
  if OpenDialog2.Execute then
  begin
    konvfilename := OpenDialog2.Filename;
    assignfile(konvin,konvfilename);
    reset(konvin);
    if not eof(konvin) then readln(konvin,konvs);
    if konvs=chr($EF)+chr($BB)+chr($BF)+'Name;Vorname;Matrikelnummer;Kartennummer;Status' then
      ShowMessage('Datei liegt bereits in UTF8-BOM-Kodierung vor.')
      else
      if konvs<>'Name;Vorname;Matrikelnummer;Kartennummer;Status' then
        ShowMessage('Erste Zeile nicht "Name;Vorname;Matrikelnummer;Kartennummer;Status" oder Datei nicht in UTF8 ohne BOM Kodierung.')
        else
        begin
          ShowMessage('Datei wird konvertiert in '+copy(konvfilename,1,length(konvfilename)-4)+'-UTF8-BOM.csv');
          assignfile(konvout,copy(konvfilename,1,length(konvfilename)-4)+'-UTF8-BOM.csv');
          rewrite(konvout);
          writeln(konvout,chr($EF)+chr($BB)+chr($BF)+'Name;Vorname;Matrikelnummer;Kartennummer;Status');
          while not eof(konvin) do
          begin
            readln(konvin,konvs);
            writeln(konvout,konvs);
          end;
          closefile(konvout);
        end;
    closefile(konvin);
  end;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin

end;



procedure TForm1.Edit1Enter(Sender: TObject);
var n:word;
    gefunden,boxenneuaufbauen:boolean;
begin
  if HasAnyThingBeenOpened then
  begin
    gefunden:=false;
    boxenneuaufbauen:=false;

    for n:=1 to zahler do
      if (daten[n,3]=Edit1.Text) or (daten[n,4]=Edit1.Text) then
         begin
           gefunden:=true;
           if (daten[n,5]='unentschuldigt') then
             begin
               Listbox4.Clear;
               Listbox4.Font.Color:=$0000BE00;
               Listbox4.Items.Add(daten[n,2]+' '+daten[n,1]);
               Timer1.Enabled:=False;
               Timer1.Interval:=2000;
               Timer1.Enabled:=True;
               daten[n,5]:='anwesend';
               boxenneuaufbauen:=true;
             end;
         end;

    if (not gefunden) and (Edit1.Text<>'') then
      begin
        Listbox4.Clear;
        ListBox4.Font.Color:=$000000C8;
        Listbox4.Items.Add(Edit1.Text);
        Timer1.Enabled:=False;
        Timer1.Interval:=2000;
        Timer1.Enabled:=True;
        ListBox3.Items.Clear;
        inc(zahler);
        daten[zahler,1]:='Unbekannt';
        daten[zahler,2]:='nn.';
        daten[zahler,3]:='1111111';
        daten[zahler,4]:=Edit1.Text;
        daten[zahler,5]:='ohne Anmeldung';
        boxenneuaufbauen:=true;
      end;

    if boxenneuaufbauen then
      begin
        ListBox1.Items.Clear;
        ListBox2.Items.Clear;
        ListBox3.Items.Clear;
        for n:=1 to zahler do
          case daten[n,5] of
            'unentschuldigt':   ListBox1.Items.Add(daten[n,3]+' ('+daten[n,4]+'):     '+daten[n,1]+' '+daten[n,2]);
            'anwesend':         ListBox2.Items.Add(daten[n,3]+' ('+daten[n,4]+'):     '+daten[n,1]+' '+daten[n,2]);
            'ohne Anmeldung':   ListBox3.Items.Add(daten[n,3]+' ('+daten[n,4]+'):     '+daten[n,1]+' '+daten[n,2]);
          end;
      end;
  end;
end;


procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  if HasAnythingBeenOpened then
    if MessageDlg('Achtung: Alle nicht gespeichterten Änderungen gehen verloren!  Programm wirklich schließen?', mtConfirmation, [mbOk, mbCancel], 0) = mrCancel then
      CanClose := false;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  ListBox4.Items.Clear;
end;


end.

